#!/usr/bin/env python
#grow-shrink-live.py
# Creator: TT
# This should allow user to light-sabre glow an existing selection current selection with live preview
# and will create an new layer when OK'ed
# Open Source
# Rel: 1.01 Fixed a bug, by setting modes to normal before merging down then setting mode to screen afterwards otherwise it's not the same as preview.
from gimpfu import *
import gtk

# Global variables to store the parameters used for our effect/work to show preview or actual layer when user OK it
global_param1 = 100 #in this example it's glow factor from 0 to 200
global_param2 = 100   #in this example it's opacity for all the layers we're dealing with
global_param3 = 10  #in this example it's iterations
global_param4 = 0   #in this example it's enhance_shadows

image = 0 #we'll set these when dialog() is called so that we can access them later
drawable = 0
has_preview = False
preview_layer1 = 0
preview_layer2 = 0
preview_layer3 = 0
preview_layer4 = 0
preview_layer5 = 0
preview_layer6 = 0

#for this operation
selection_channel = 0
last_factor = 0;
def apply_effect(): #function to do work on either preview layer or actual drawable when user clicks OK
    global image
    global has_preview,preview_layer1,preview_layer2,preview_layer3,preview_layer4,preview_layer5,preview_layer6 #deal with preview layer
    global last_factor
    factor = global_param1/100.0
    opacity = global_param2
    pdb.gimp_layer_set_opacity(preview_layer1,opacity)
    pdb.gimp_layer_set_opacity(preview_layer2,opacity)
    pdb.gimp_layer_set_opacity(preview_layer3,opacity)
    pdb.gimp_layer_set_opacity(preview_layer4,opacity)
    pdb.gimp_layer_set_opacity(preview_layer5,opacity)
    pdb.gimp_layer_set_opacity(preview_layer6,opacity)
    if last_factor != factor:
        pdb.gimp_selection_none(image)
        pdb.gimp_edit_clear(preview_layer1)
        pdb.gimp_edit_clear(preview_layer2)
        pdb.gimp_edit_clear(preview_layer3)
        pdb.gimp_edit_clear(preview_layer4)
        pdb.gimp_edit_clear(preview_layer5)
        pdb.gimp_edit_clear(preview_layer6)
        pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,selection_channel) #first we selected the original saved channel
        #do something to it to show it's effect so that user can distinguish between selected area or not
        pdb.gimp_drawable_edit_fill(preview_layer1,FILL_FOREGROUND)
        pdb.gimp_drawable_edit_fill(preview_layer2,FILL_FOREGROUND)
        pdb.gimp_drawable_edit_fill(preview_layer3,FILL_FOREGROUND)
        pdb.gimp_drawable_edit_fill(preview_layer4,FILL_FOREGROUND)
        pdb.gimp_drawable_edit_fill(preview_layer5,FILL_FOREGROUND)
        pdb.gimp_drawable_edit_fill(preview_layer6,FILL_FOREGROUND)
        pdb.gimp_selection_none(image)
        pdb.plug_in_gauss_iir2(image,preview_layer1,2*factor,2*factor)
        pdb.plug_in_gauss_iir2(image,preview_layer2,15*factor,15*factor)
        pdb.plug_in_gauss_iir2(image,preview_layer3,50*factor,50*factor)
        pdb.plug_in_gauss_iir2(image,preview_layer4,150*factor,150*factor)
        #deal with possibly bigger than 500 maximum
        radius1 = 300*factor
        while radius1 > 500:
            pdb.plug_in_gauss_iir2(image,preview_layer5,500,500)
            radius1-=500;
        pdb.plug_in_gauss_iir2(image,preview_layer5,radius1,radius1)

        #same thing but for 6th layer
        radius1 = 600*factor
        while radius1 > 500:
            pdb.plug_in_gauss_iir2(image,preview_layer6,500,500)
            radius1-=500;
        pdb.plug_in_gauss_iir2(image,preview_layer6,radius1,radius1)
        
        #pdb.gimp_ellipse_select(image,image.width/2-width/2,image.height/2-height/2,width,height,CHANNEL_OP_REPLACE,TRUE,FALSE,0)
        #pdb.gimp_drawable_invert(layer,TRUE)
        #pdb.gimp_selection_none(image)
        last_factor = factor
    gimp.displays_flush()

def apply_final(): #wrapper to apply effect on final and remove preview_layer meant to be called by on_ok_button_clicked
    global preview_layer
    pdb.gimp_image_undo_group_start(image) #so it's undone in Ctrl+Z
    pdb.gimp_image_undo_enable(image) #so that user can undo this next step
    apply_effect()
    pdb.gimp_layer_set_mode(preview_layer6,LAYER_MODE_NORMAL)
    pdb.gimp_layer_set_mode(preview_layer5,LAYER_MODE_NORMAL)
    pdb.gimp_layer_set_mode(preview_layer4,LAYER_MODE_NORMAL)
    pdb.gimp_layer_set_mode(preview_layer3,LAYER_MODE_NORMAL)
    pdb.gimp_layer_set_mode(preview_layer2,LAYER_MODE_NORMAL)
    pdb.gimp_layer_set_mode(preview_layer1,LAYER_MODE_NORMAL)
    next_layer = pdb.gimp_image_merge_down(image,preview_layer6,CLIP_TO_IMAGE)
    next_layer = pdb.gimp_image_merge_down(image,next_layer,CLIP_TO_IMAGE)
    next_layer = pdb.gimp_image_merge_down(image,next_layer,CLIP_TO_IMAGE)
    next_layer = pdb.gimp_image_merge_down(image,next_layer,CLIP_TO_IMAGE)
    next_layer = pdb.gimp_image_merge_down(image,next_layer,CLIP_TO_IMAGE)
    pdb.gimp_layer_set_mode(next_layer,LAYER_MODE_SCREEN)
    next_layer = pdb.gimp_image_undo_group_end(image)
    if has_preview:
        pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,selection_channel) #first we selected the original saved channel
        pdb.gimp_image_remove_channel(image,selection_channel) #so that we don't leave a saved channel laying around
        #pdb.gimp_image_remove_layer(image,preview_layer)
    pdb.gimp_image_set_active_layer(image,drawable)
    #pdb.gimp_context_set_foreground(save_foreground)
    gimp.displays_flush()
    
# Function to update the live preview
def update_live_preview(): #this is called everytime some parameter changes
    global global_param1, global_param2, global_param3, global_param4
    global image,drawable
    global has_preview,preview_layer1,preview_layer2,preview_layer3,preview_layer4,preview_layer5,preview_layer6 #deal with preview layer
    global selection_channel #this will save our current selection
    # Apply your plugin's effect using the current parameters
    # Use global_param1 and global_param2 to access the user's inputs
    if not has_preview: #create a preview layer
        #pdb.gimp_message("Creating preview")
        preview_layer1 = pdb.gimp_layer_new(image,image.width,image.height,RGBA_IMAGE,"Light Saber",global_param2,LAYER_MODE_SCREEN)
        pdb.gimp_image_insert_layer(image,preview_layer1,None,0)
        preview_layer2 = pdb.gimp_layer_new(image,image.width,image.height,RGBA_IMAGE,"Light Saber 2",global_param2,LAYER_MODE_SCREEN)
        pdb.gimp_image_insert_layer(image,preview_layer2,None,0) #insert top most so we see it
        preview_layer3 = pdb.gimp_layer_new(image,image.width,image.height,RGBA_IMAGE,"Light Saber 3",global_param2,LAYER_MODE_SCREEN)
        pdb.gimp_image_insert_layer(image,preview_layer3,None,0) #insert top most so we see it
        preview_layer4 = pdb.gimp_layer_new(image,image.width,image.height,RGBA_IMAGE,"Light Saber 4",global_param2,LAYER_MODE_SCREEN)
        pdb.gimp_image_insert_layer(image,preview_layer4,None,0) #insert top most so we see it
        preview_layer5 = pdb.gimp_layer_new(image,image.width,image.height,RGBA_IMAGE,"Light Saber 5",global_param2,LAYER_MODE_SCREEN)
        pdb.gimp_image_insert_layer(image,preview_layer5,None,0) #insert top most so we see it
        preview_layer6 = pdb.gimp_layer_new(image,image.width,image.height,RGBA_IMAGE,"Light Saber 6",global_param2,LAYER_MODE_SCREEN)
        pdb.gimp_image_insert_layer(image,preview_layer6,None,0) #insert top most so we see it
        non_empty,x1,y1,x2,y2 = pdb.gimp_selection_bounds(image)
        if non_empty == TRUE:
            pass #there's already a selection
        else:
            #select some funky rectangle to see the effect if there's no current selection
            pdb.gimp_image_select_rectangle(image,CHANNEL_OP_REPLACE,drawable.width/4,drawable.height/4,drawable.width/2,drawable.height/2) #if there's no selection we just select the whole image and work with that
            pdb.gimp_image_select_rectangle(image,CHANNEL_OP_SUBTRACT,drawable.width/4+drawable.width/20,drawable.height/4+drawable.height/20,drawable.width/2-drawable.width/10,drawable.height/2-drawable.height/10) #if there's no selection we just select the whole image and work with that
        selection_channel = pdb.gimp_selection_save(image)
        has_preview = True #now set it true so we can deal with existing layer in later calls
    else: # already have preview layer
        pass
        # #pdb.gimp_message("Removing existing and creating new Preview")
        # pdb.gimp_image_remove_layer(image,preview_layer) #remove it to create a new one to work on
        # preview_layer = pdb.gimp_layer_new(image,image.width,image.height,RGBA_IMAGE,"preview",50,LAYER_MODE_NORMAL)
        # pdb.gimp_image_insert_layer(image,preview_layer,None,0) #insert top most so we see it
    #pdb.gimp_image_set_active_layer(image,preview_layer)
    #debug message
    #pdb.gimp_message(str(global_param1)+","+str(global_param2)+","+str(global_param3)+","+str(global_param4))

    apply_effect()
    
    # Update the live preview layer with the modified image
    
save_foreground = 0
hilightcolor = (255,0,0)
def light_sabre_live(image_, drawable_):
    global image, drawable, save_foreground
    #save these for updates
    image = image_
    pdb.gimp_image_undo_disable(image) #for speed and also when user undo it doesn't see our preview creations/deletions
    drawable = drawable_  
    #save_foreground = pdb.gimp_context_get_foreground()
    #pdb.gimp_context_set_foreground(hilightcolor)

    dialog = gtk.Dialog("Light-Sabre Selection with Live Preview", None, gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT)
    dialog.set_default_size(600, 100)

    # Create an HBox to hold the label and slider -------------------------------------------------------------
    hbox = gtk.HBox()
    dialog.vbox.pack_start(hbox, expand=True, fill=True)

    # Create a label on the left-hand side
    label1 = gtk.Label("Glow Size Factor:")
    hbox.pack_start(label1, expand=False, fill=False, padding=5)

    # Create an adjustment for the HScale (slider) with a range from 10 to 90
    adjustment1 = gtk.Adjustment(value=100, lower=0, upper=300, step_incr=1, page_incr=0)
    param1_scale = gtk.HScale(adjustment=adjustment1)
    param1_scale.set_digits(0)  # Display only integers
    hbox.pack_start(param1_scale, expand=True, fill=True, padding=5)
    # Connect callback functions for user interaction
    param1_scale.connect("value-changed", on_param1_changed)

    # # Create an HBox to hold the label and slider -------------------------------------------------------------
    hbox2 = gtk.HBox()
    dialog.vbox.pack_start(hbox2, expand=True, fill=True)

    # Create a label on the left-hand side
    label2 = gtk.Label("Glow Opacity:")
    hbox2.pack_start(label2, expand=False, fill=False, padding=5)

    # Create an adjustment for the HScale (slider) with a range from 10 to 90
    adjustment2 = gtk.Adjustment(value=100, lower=0, upper=100, step_incr=1, page_incr=0)
    param2_scale = gtk.HScale(adjustment=adjustment2)
    param2_scale.set_digits(0)  # Display only integers
    hbox2.pack_start(param2_scale, expand=True, fill=True, padding=5)
    # Connect callback functions for user interaction
    param2_scale.connect("value-changed", on_param2_changed)

    # # Create an HBox to hold the label and slider -------------------------------------------------------------
    # hbox3 = gtk.HBox()
    # dialog.vbox.pack_start(hbox3, expand=True, fill=True)

    # # Create a label on the left-hand side
    # label3 = gtk.Label("iterations:")
    # hbox3.pack_start(label3, expand=False, fill=False, padding=5)

    # # Create an adjustment for the HScale (slider) with a range from 10 to 90
    # adjustment3 = gtk.Adjustment(value=10, lower=1, upper=30, step_incr=1, page_incr=0)
    # param3_scale = gtk.HScale(adjustment=adjustment3)
    # param3_scale.set_digits(0)  # Display only integers
    # hbox3.pack_start(param3_scale, expand=True, fill=True, padding=5)
    # # Connect callback functions for user interaction
    # param3_scale.connect("value-changed", on_param3_changed)

    # Add an OK button
    ok_button = dialog.add_button(gtk.STOCK_OK, gtk.RESPONSE_OK)
    ok_button.connect("clicked", on_ok_button_clicked)
    # Show the dialog
    dialog.show_all()
    update_live_preview() #call this once so we see effect
    dialog.run()
    

# Callback function for updating the live preview when param1 changes
def on_param1_changed(scale):
    global global_param1
    global_param1 = scale.get_value()
    update_live_preview()

# Callback function for updating the live preview when param2 changes
def on_param2_changed(scale):
    global global_param2
    global_param2 = scale.get_value()
    update_live_preview()

# Callback function for the OK button
def on_ok_button_clicked(button, data=None):
    global drawable
    apply_final() #preview layer because we don't want to apply the invert to final layer it's just for viewing
    button.get_toplevel().destroy() #destroys the gtk dialog window
# Register the Python-Fu plugin
register(
    "python_fu_light_sabre_live",
    "Light-Sabre existing Selection with Live Preview",
    "Light-Sabre existing Selection with Live Preview",
    "TT",
    "TT",
    "November 9, 2023",
    "<Image>/Python-Fu/Live Preview/Light-Sabre Live",  # Menu location
    "*",  # Image type
    [],
    [],
    light_sabre_live
)

main()